# -*- coding: utf-8 -*-
# utilities

# Duplicate console output to file

import sys

class DupStream:
    def __init__(self, stream1, stream2):
        self.stream1 = stream1
        self.stream2 = stream2

    def write(self, data):
        self.stream1.write(data)
        self.stream2.write(data)

    def flush(self):
        self.stream1.flush()
        self.stream2.flush()


class Tee:
    def __init__(self, name):
        self.file = open(name, 'w')
        self.stdoutbak = sys.stdout
        self.stderrbak = sys.stderr
        sys.stdout = DupStream(sys.stdout, self.file)
        sys.stderr = DupStream(sys.stderr, self.file)

    def __del__(self):
        sys.stdout = self.stdoutbak
        sys.stderr = self.stderrbak
        self.file.close()


def parseargs():
    """
    parses command line arguments
    """
    import os
    import argparse
    parser = argparse.ArgumentParser()
    # parser.add_argument(
    #     "-v", "--verb", help="increase output verbosity", action="count", default=0)
    parser.add_argument(
        "--nogui", help="disable any graphical output", action="store_true")
    parser.add_argument(
        "--post", help="display existing results", action="store_true")
    parser.add_argument(
        "--csv", help="convert results to csv", action="store_true")
    parser.add_argument("-k", help="nb of threads", type=int, default=os.cpu_count())
    parser.add_argument('file', help='python file', type=str, nargs='?')
    args = parser.parse_args()
    return args
